package simple.javacard;

/**
 * Titre :        Simple
 * Description :  A simple JavaCard applet and its OCF associated CardService and CardServiceFactory class
 * Copyright :    Copyright (c) 2002
 * Socit :
 * @author Unknown
 * @version 1.0
 */

// Listing One

import javacard.framework.*;

public class SimpleString extends Applet
{
  final static byte SimpleString_CLA = (byte)0x00;
  final static byte SET = (byte)0x10;
  final static byte GET = (byte)0x20;
  byte buffer[];		// Holds APDU's for processing
  byte TheBuffer[];	// Holds the string data on the card

  private SimpleString(){
		TheBuffer = new byte[127];
		register();
  }
  public static void install(APDU apdu){
    new SimpleString();
  }
  public boolean select(){
		return true;
  }
  public void process(APDU apdu){
		buffer = apdu.getBuffer();
		if (buffer[ISO.OFFSET_CLA] != SimpleString_CLA)
			ISOException.throwIt(ISO.SW_CLA_NOT_SUPPORTED);
		switch (buffer[ISO.OFFSET_INS])
{
			case SET:
				setString(apdu);
				return;
			case GET:
				getString(apdu);
				return;
			default:
				ISOException.throwIt(ISO.SW_INS_NOT_SUPPORTED);
		}
  }
  private void setString(APDU apdu){
		buffer = apdu.getBuffer();
		byte size = (byte)(apdu.setIncomingAndReceive());
		byte index;
//Store the string length and the string itself
		TheBuffer[0] = size;
Util.arrayCopy(buffer, ISO.OFFSET_CDATA, TheBuffer, (short)1, (short)size);
		return;
}
  private void getString(APDU apdu){
		buffer = apdu.getBuffer();
		byte numBytes = buffer[ISO.OFFSET_LC];
		if (numBytes == 0)
	  	ISOException.throwIt((short)( SW_WRONG_LENGTH + TheBuffer[0]));
		apdu.setOutgoing();
		apdu.setOutgoingLength(numBytes);
Util.arrayCopy(TheBuffer, (short)1, buffer, (short)0, (short)numBytes);
		apdu.sendBytes((short)0,(short)numBytes);
		return;
  }

} // end SimpleString class
