package simple.opencard;

/**
 * Titre :        Simple
 * Description :  A simple JavaCard applet and its OCF associated CardService and CardServiceFactory class
 * Copyright :    Copyright (c) 2002
 * Socit :
 * @author Unknown
 * @version 1.0
 */

import java.io.*;
import java.util.*;
import opencard.core.terminal.*;
import opencard.core.service.*;
import opencard.opt.service.*;

public class SimpleStringCardServiceFactory extends CardServiceFactory {
private final static byte supportedJavaCardATRs[][] = {
{ // Cyberflex card's Answer To Reset (ATR)
    (byte)0x3B,(byte)0x16,(byte)0x94,(byte)0x81,
    (byte)0x10,(byte)05,(byte)00, (byte)00,
    (byte)0x51
}
// add here GemXpresso ATR
};


private static Vector services_ = null;
private static Vector cardids_ = null;

// register card service with OCF
static {
  services_ = new Vector();
  services_.addElement(SimpleStringCardService.class);

  cardids_= new Vector();
  for(int i=0; i<supportedJavaCardATRs.length; i++){
        cardids_.addElement(new CardID(supportedJavaCardATRs[i]));
  }
}

public SimpleStringCardServiceFactory(){
  super();
}

protected Enumeration getClasses(CardType type){
  return services_.elements();
}

protected CardType getCardType(CardID cid, CardServiceScheduler scheduler){
  for (Enumeration e = cardids_.elements() ; e.hasMoreElements() ;) {
    if(cid.equals((CardID)e.nextElement())){
      CardType ct=new CardType(1234);
      ct.setInfo(cid.getATR());
      return ct;
    }
  }
  return CardType.UNSUPPORTED;
}

// check whether the factory knows the smart card OS
public boolean knows(CardID cardID){
}
} // end SimpleStringCardServiceFactory class
